// Test polimorphic unions more!
// $Id: t8.g,v 1.3 2002/02/25 11:15:11 malekith Exp $

union <'a>list {
	void Nil;
	*['a, <'a>list] Cons;
}

int length(<'a>list l)
{
	switch l {
	case Nil[]:
		return 0;
	case Cons[hd, tl]:
		return 1 + length(tl);
	}
}

void iter(*('a) -> void f, <'a>list l)
{
	switch l {
	case Nil[]:
		return;
		
	case Cons[hd, tl]:
		f(hd);
		iter(f, tl);
	}
}

<'b>list map(*('a) -> 'b f, <'a>list l)
{
	switch l {
	case Nil[]:
		return Nil[];		

	case Cons[hd, tl]:
		return Cons[f(hd), map(f, tl)];
	}
}

<'a>list concat(<'a>list x, <'a>list y)
{
	switch x {
	case Nil[]:
		return y;
	case Cons[hd, tl]:
		return Cons[hd, concat(tl, y)];
	}
}

<'a>list filter(*('a) -> bool f, <'a>list l)
{
	switch l {
	case Nil[]:
		return Nil[];
	case Cons[x, xs]:
		if (f(x)) {
			return Cons[x, filter(f, xs)];
		} else {
			return filter(f, xs);
		}
	}
	
}

'a fold_left (*('a, 'b) -> 'a f, 'a init, <'b>list li) 
{
	switch li {
	case Nil[]: 
		return init;
	case Cons[hd, tl]: 
		return fold_left(f, f(init, hd), tl);
	}
}

<'a>list qsort(*('a, 'a) -> int cmp, <'a>list l)
{
	'a m;
	
	switch l {
	case Nil[]:
		return l;
	case Cons[hd, r]:
		m = hd;
		
		<'a>list le = filter(fun ('a x) -> bool is 
						(cmp(x, m) <= 0), r);
		<'a>list gt = filter(fun ('a x) -> bool is 
						(cmp(x, m) > 0), r);
		return concat(qsort(cmp, le), Cons[hd, qsort(cmp, gt)]);
	}
}

void print_int_list(<int>list l)
{
	void print(int x) 
	{
		print_int(x);
		print_string(",");
	}

	print_string("[");
	iter(print, l);

	print_string("] ");
}

section init
{
	<int>list i;
	int cnt = 0;
	int adder(int x) { cnt = (cnt + 1) % 4; return x + cnt; }
	
	i = Cons[3, Cons[1, Cons[2, Nil]]];
	i = concat(map(fun (int x) -> int is ((3 - x) * 2), i), i);
	i = concat(map(fun (int x) -> int is ((3 - x) * 2), i), i);
	print_int_list(i);
	i = map(adder, i);
	print_int_list(i);
	print_int_list(qsort(fun (int x, int y) -> int is (x - y), i));
	print_int_list(qsort(fun (int x, int y) -> int is (y - x), i));
	
	print_int (fold_left(fun (int x, int y) -> int is (x+y), 0, i));

	print_string(".\n");
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: [6,-2,2,0,4,2,0,4,2,3,1,2,] [7,0,5,0,5,4,3,4,3,5,4,2,] [0,0,2,3,3,4,4,4,5,5,5,7,] [7,5,5,5,4,4,4,3,3,2,0,0,] 42.
 */
